<?php
  function isIphone($user_agent=NULL) {
    if(!isset($user_agent)) {
        $user_agent = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : '';
    }
    return (strpos($user_agent, 'iPhone') !== FALSE);
  }
?>
<!doctype html>
<html>
  <head>
    <meta charset="utf-8">

    <title>Fuzed</title>
    <meta name="description" content="">
    <meta name="author" content="">

    <meta name="HandheldFriendly" content="True">
    <meta name="MobileOptimized" content="320">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link href='http://fonts.googleapis.com/css?family=Frijole' rel='stylesheet' type='text/css'>
    <link rel="stylesheet" href="css/main.css">
    <link rel="stylesheet" href="css/animations.css">
  </head>

  <body>
    <div id="status-bar">
      <div id="health"><div class="img"></div><div class="value">100</div></div>
      <div id="coins"><div class="img"></div><div class="value">0</div></div>
      <div id="bombs"><div class="img"></div><div class="value">10</div></div>
      <div id="temp"><div class="img"></div><div class="value">21<span style="font-size: 14px;">&#8451;</span></div></div>
    </div>
    <div id="action-bar">
      <div class="reload button"><div class="icon"></div></div>
      <div class="plant-bomb button"><div class="icon"></div></div>
    </div>
    <div id="pause">
      <h1 class="main-title">Pause</h1>
      <div style="clear: both: height: 1px"></div>
      <div class="left"><h4 id="aboutgame" class="small-title aboutgame">About</h4></div>
      <div class="right"><h4 class="small-title resumegame">Resume</h4></div>
    </div>

    <div id="about">
      <h1 class="main-title">About</h1>
      <div class="text">
        Created by Tanel Tähepõld. Graphics by Marc Russell [spicypixel.net].<br/>Built using HTML, JavaScript, CSS, Google Fonts, jQuery, CraftyJS and PhoneGap.
      </div>
      <div style="clear: both: height: 1px"></div>
      <div class="right"><h4 class="small-title resumegame">Resume</h4></div>
    </div>
    <script src="js/cordova_<?php echo isIphone() ? "ios" : "android"; ?>-1.7.0rc1.js"></script>
    <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.6.2/jquery.min.js"></script>
    <script src="js/crafty.js"></script>
    <script src="js/Arduino.js"></script>
    <script src="js/TiledLevel.js"></script>
    <script src="js/Fuzed.js"></script>
    <script src="js/Components.js"></script>
    <script src="js/Scenes.js"></script>
    <script src="js/init.js"></script>
  </body>
</html>