(function() {
  var removeStage = function() {
    $("#status-bar").hide(); 
    $("#action-bar").hide();
    Fuzed.trackTemperature(false);
  };
  
  /**
   * Loading scene
   */
  Crafty.scene("loading", function() {
    // Load assets and trigger game main scene
    Crafty.load(
      [
        "gfx/gripe.png", "gfx/grog.png", "gfx/explosion.png", "gfx/coin_gold.png", 
        "gfx/bomb_floor.png", "gfx/mine_floor.png", "gfx/portal.png"
      ], 
      function() {
        setTimeout(function() {
          Crafty.scene("level01");
        }, 2000);
      }
    );

    Crafty.e("2D, DOM, Text, main-title")
    .attr({w: Crafty.viewport.width, h: 100, x: 0, y: 80})
    .text("FUZED");

    Crafty.e("2D, DOM, Text, small-title")
    .attr({w: Crafty.viewport.width, h: 100, x: 0, y: 140})
    .text("LOADING...");
  });

  /**
   * Game over scene
   */
  Crafty.scene("gameover", function() {
    removeStage();

    Crafty.e("2D, DOM, Text, main-title")
    .attr({w: Crafty.viewport.width, h: 100, x: 0, y: 80})
    .text("GAME OVER");

     Crafty.e("2D, DOM, Text, small-title, play-again")
    .attr({w: Crafty.viewport.width, h: 100, x: 0, y: 160})
    .text("PLAY AGAIN");
  });

  /**
   * Stage completed scene
   */ 
  Crafty.scene("stageCompleted", function() {
    removeStage();
    
    Crafty.e("2D, DOM, Text, main-title")
    .attr({w: Crafty.viewport.width, h: 100, x: 0, y: 50})
    .text("STAGE COMPLETED");
    Crafty.e("2D, DOM, Text, small-title, play-again")
    .attr({w: Crafty.viewport.width, h: 100, x: 0, y: 180})
    .text("PLAY AGAIN");
  });

  /**
   * Game main scenes
   */
  Crafty.scene("level01", function() {
    // Show status-bar
    $("#health .value").html("100");
    $("#coins .value").html("0");
    $("#bombs .value").html("10");

    $("#status-bar").show();
    $("#action-bar").show();
    // Create stage
    Crafty.e("TiledLevel").tiledLevel("levels/level01.json", "DOM", function() {
      var i,
          enemyBatch = Crafty.e("EnemyBatch");

      Fuzed.enemies = [];
      for (i = 1; i <= 5; i++) {
        Fuzed.enemies.push(Crafty.e("EnemyComponent, grog").attr({
          name: 'grog'
        }));
      }

      // Use one EnterFrame for all enemies
      // Huge performance boost
      enemyBatch.bind("EnterFrame", function() {
        $.each(Fuzed.enemies, function(i, e) {
          e.onEnterFrame();
        });
      });

      // Put coins
      for (i = 1; i <= 2; i++) {
        Crafty.e("Coin").attr({
          x: 296+i*32,
          y: 80
        });
      }

      for (i = 1; i <= 3; i++) {
        Crafty.e("Coin").attr({
          x:298+i*32,
          y: 176
        });
      }

      for (i = 1; i <= 3; i++) {
        Crafty.e("Coin").attr({
          x: 40+i*32,
          y: 240
        });
      }

      // Create portals
      Fuzed.portals = [
        Crafty.e("Portal")
        .attr({
          x: 16, y: 144, to: 3
        }),
        Crafty.e("Portal")
        .attr({
          x: 560, y: 304, to: 2
        }),
        Crafty.e("Portal")
        .attr({
          x: 560, y: 64
        }),
        // Portal 4
        Crafty.e("Portal")
        .attr({
          x: 16, y: 64
        })
      ];

      // Create mines
      for (i = 1; i <=3; i++) {
        Crafty.e("Mine");
      }

      // Create player instance
      Fuzed.Player = Crafty.e("Player")
                    .onHit("finish", function() {
                      Crafty.viewport.x = 0;
                      Crafty.viewport.y = 0;
                      Crafty.scene("stageCompleted");
                    })
                    .bind("gameOver", function() {
                      Crafty.viewport.x = 0;
                      Crafty.viewport.y = 0;
                      Crafty.scene("gameover");
                    });
      // Follow player in viewport
      Crafty.viewport.follow(Fuzed.Player);
    }, this);
  });
})();