$(document).ready(function() {
  var body = $("body");
  // Init crafty
  Crafty.init(Math.min(body.width(), Fuzed.world[0]), Math.min(body.height(), Fuzed.world[1]));
  Crafty.background("#55b4ff"); 
  
  // Create sprite maps
  Crafty.sprite(32, "gfx/gripe.png", {
    gripe: [0, 0]
  });
  
  Crafty.sprite(32, "gfx/grog.png", {
    grog: [0, 0]
  });
  
  Crafty.sprite(64, "gfx/explosion.png", {
    explosion_sprite: [0, 0]
  });

  Crafty.sprite(16, "gfx/bomb_floor.png", {
    bomb_floor: [0, 0]
  });

  Crafty.sprite(16, "gfx/mine_floor.png", {
    mine_floor: [0, 0]
  });
  
  Crafty.sprite(64, "gfx/portal.png", {
    portal_sprite: [0, 0]
  });
  
  Crafty.sprite(16, "gfx/coin_gold.png", {
    coin_gold: [0, 0]
  });
  
  var touchEventHandler = function(e) {
    var target = $(e.target),
        parent = target.parent("div");
    if (target.hasClass("play-again")) {
      Crafty.scene("level01");
    }
    else if (target.hasClass("plant-bomb") || parent.hasClass("plant-bomb")) {
      Fuzed.Player.plantBombAction();
    }
    else if (target.hasClass("reload") || parent.hasClass("reload")) {
      document.location.reload();
    }
    else {
      Fuzed.Player.jumpAction();
    }
  };
  
  // Add listeners
  document.body.addEventListener("click", touchEventHandler);
  document.body.addEventListener("touchstart", touchEventHandler);
  
  // Trigger loading scene
  Crafty.scene("loading");
});

/**
 * Shake entire viewport
 * 
 * @param {Integer} time
 * @return void
 */
Crafty.viewport.shake = (function() {
  var step = 10,
      mod = 1,
      interval,
      timeout;
    
  return function(time) {
    interval = setInterval(function() {
      var move = mod*step;
      Crafty.viewport.x -= move;
      Crafty.viewport.y += move;
      mod *= -1;
    }, 200);
    
    timeout && clearTimeout(timeout);
    timeout = setTimeout(function() {
      clearInterval(interval);
    }, time || 2000);
  }
})();

/**
 * Fix for viewport _clamp function
 * Default function was not working correctly
 */ 
Crafty.viewport._clamp = function () {
  var bounds = {
      x: [0, Fuzed.world[0]-Crafty.viewport.width],
      y: [0, Fuzed.world[1]-Crafty.viewport.height]
    },
    x = Crafty.viewport.x,
    y = Crafty.viewport.y;

    if (x > bounds.x[0]) {
      x = 0;
    }
    else if (Math.abs(x) > bounds.x[1]) {
      x = -1*bounds.x[1];
    }
    if (Math.abs(y) > bounds.y[1]) {
      y = -1*bounds.y[1];
    }
    else if (y > bounds.y[0]) {
      y = 0;
    }
    Crafty.viewport.x = x;
    Crafty.viewport.y = y;
};

/**
 * Makes snow for stage
 * 
 * @param {Boolean} status
 */
Crafty.viewport.snow = function(status) {
  if (status) {
    $('.snow').css("opacity", 1);
    $('.snow').removeClass("snow-hide");
  }
  else {
    $('.snow').css("opacity", 0);
  }
}

/** Callback for android **/
Fuzed.toggleSnow = (function() {
  var status = true;
  
  return function() {
    Crafty.viewport.snow(status);
    status = status ? false : true;
  };
})();

Fuzed.toggleShake = function() {
  navigator.notification && navigator.notification.vibrate(2000);
  Crafty.viewport.shake(2000);
};